diff --git a/mysql-test/main/statement-expr.test b/mysql-test/main/statement-expr.test
new file mode 100644
index 0000000..7b96a7d
--- /dev/null
+++ b/mysql-test/main/statement-expr.test
@@ -0,0 +1,291 @@
+# Testing expressions of different kinds in various non-SELECT statements
+
+
+#
+# Subselects in non-SELECT statements
+#
+
+CREATE TABLE t1 (id INT, id1 INT);
+INSERT INTO t1 VALUES (1,7);
+INSERT INTO t1 VALUES (1,8);
+SELECT ROW(1,7) IN (SELECT id, id1 FROM t1 WHERE id1= 8);
+EXECUTE IMMEDIATE 'SELECT ROW(1, 7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)';
+DROP TABLE t1;
+
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING (SELECT * FROM t1);
+
+
+CREATE TABLE t1 (id INT);
+INSERT INTO t1 VALUES (10);
+CREATE PROCEDURE p1(a INT) BEGIN END;
+CALL p1((1) IN (SELECT * FROM t1));
+CALL p1(EXISTS (SELECT * FROM t1));
+DROP PROCEDURE p1;
+DROP TABLE t1;
+
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+
+DELIMITER $$;
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_PARSE_ERROR
+PREPARE stmt FROM (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+PREPARE stmt FROM EXISTS (SELECT * FROM t1);
+
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE EXISTS (SELECT * FROM t1);
+
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION (1 IN (SELECT * FROM t1)) @errno=MYSQL_ERRNO;
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION EXISTS (SELECT * FROM t1) @errno=MYSQL_ERRNO;
+
+--error ER_PARSE_ERROR
+PURGE BINARY LOGS BEFORE (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+PURGE BINARY LOGS BEFORE EXISTS (SELECT * FROM t1);
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DO 1 IN (SELECT * FROM t1);
+DO EXISTS (SELECT * FROM t1);
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+
+#TODO: warp into CREATE
+
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b.c;
+
+
+CREATE PROCEDURE p1(a INT) BEGIN END;
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier);
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier.a);
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier.a.b);
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier.a.b.c);
+DROP PROCEDURE p1;
+
+
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier.a.b.c;
+
+
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier.a.b.c;
+
+
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier @errno=MYSQL_ERRNO;
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier.a @errno=MYSQL_ERRNO;
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b @errno=MYSQL_ERRNO;
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b.c @errno=MYSQL_ERRNO;
+
+
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b.c;
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1()
+BEGIN
+  DO unknown_identifier;
+END;
+$$
+DELIMITER ;$$
+
+
+--echo #
+--echo # MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+--echo #
+
+--echo # (aggreate functions)
+
+--error ER_INVALID_GROUP_FUNC_USE
+EXECUTE IMMEDIATE 'SELECT ?' USING SUM(1);
+
+
+CREATE PROCEDURE p1(a INT) BEGIN END;
+--error ER_INVALID_GROUP_FUNC_USE
+CALL p1(SUM(1));
+DROP PROCEDURE p1;
+
+
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=SUM(1);
+
+
+DELIMITER $$;
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=SUM(1);
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+PREPARE stmt FROM SUM(1);
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+EXECUTE IMMEDIATE SUM(1);
+
+
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION SUM(1) @errno=MYSQL_ERRNO;
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+PURGE BINARY LOGS BEFORE SUM(1);
+
+
+
+--echo #
+--echo # MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+--echo #
+
+--echo # (window functions)
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+EXECUTE IMMEDIATE 'SELECT ?' USING ROW_NUMBER() OVER ();
+
+
+CREATE PROCEDURE p1(a INT) BEGIN END;
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CALL p1(ROW_NUMBER() OVER ());
+DROP PROCEDURE p1;
+
+
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+
+
+DELIMITER $$;
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+PREPARE stmt FROM ROW_NUMBER() OVER ();
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+EXECUTE IMMEDIATE ROW_NUMBER() OVER ();
+
+
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION ROW_NUMBER() OVER () @errno=MYSQL_ERRNO;
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+PURGE BINARY LOGS BEFORE ROW_NUMBER() OVER ();
diff --git a/mysql-test/suite/compat/oracle/r/sp-expr.result b/mysql-test/suite/compat/oracle/r/sp-expr.result
new file mode 100644
index 0000000..e9383d5
--- /dev/null
+++ b/mysql-test/suite/compat/oracle/r/sp-expr.result
@@ -0,0 +1,585 @@
+SET sql_mode=ORACLE;
+#
+# Start of 10.4 tests
+#
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+BEGIN
+CASE ((1) IN (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+1
+1
+BEGIN
+CASE (EXISTS (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+1
+1
+BEGIN
+IF ((1) IN (SELECT a FROM t1)) THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+1
+1
+BEGIN
+IF (EXISTS (SELECT a FROM t1)) THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+1
+1
+BEGIN
+WHILE ((1234) IN (SELECT * FROM t1)) LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+BEGIN
+WHILE (EXISTS (SELECT * FROM t1 WHERE a=1234)) LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL (1 IN (SELECT * FROM t1))
+END REPEAT;
+END;
+$$
+1
+1
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL EXISTS (SELECT * FROM t1 WHERE a=1)
+END REPEAT;
+END;
+$$
+1
+1
+BEGIN
+FOR i IN 0..(1 IN (SELECT * FROM t1))
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+i
+0
+i
+1
+BEGIN
+FOR i IN 0..EXISTS (SELECT * FROM t1 WHERE a=1)
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+i
+0
+i
+1
+DROP TABLE t1;
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (10);
+DECLARE
+a INT DEFAULT ((10) IN (SELECT * FROM t1));
+BEGIN
+SELECT a;
+END;
+$$
+a
+1
+DECLARE
+a INT DEFAULT EXISTS (SELECT * FROM t1);
+BEGIN
+SELECT a;
+END;
+$$
+a
+1
+DROP TABLE t1;
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+CREATE FUNCTION f1() RETURN INT AS
+BEGIN
+RETURN ((1) IN (SELECT * FROM t1));
+END;
+$$
+CREATE FUNCTION f2() RETURN INT AS
+BEGIN
+RETURN EXISTS (SELECT * FROM t1 WHERE a=1);
+END;
+$$
+SELECT f1();
+f1()
+1
+SELECT f2();
+f2()
+1
+DROP FUNCTION f1;
+DROP FUNCTION f2;
+DROP TABLE t1;
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DECLARE
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(1 IN (SELECT * FROM t1));
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+va
+2
+DECLARE
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(EXISTS (SELECT * FROM t1));
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+va
+2
+DROP TABLE t1;
+#
+# MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+#
+CREATE PROCEDURE p1() AS
+BEGIN
+CASE unknown_identifier WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+CASE unknown_identifier.a WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+CASE unknown_identifier.a.b WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+CASE unknown_identifier.a.b.c WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+IF unknown_identifier THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+IF unknown_identifier.a THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+IF unknown_identifier.a.b THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+IF unknown_identifier.a.b.c THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+WHILE unknown_identifier LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+WHILE unknown_identifier.a LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+WHILE unknown_identifier.a.b LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+WHILE unknown_identifier.a.b.c LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier.a;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier.a.b;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier.a.b.c;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN 0..unknown_identifier
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN 0..unknown_identifier.field1
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier.field1
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN 0..unknown_identifier.field1.field2
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR 42000: Undeclared variable: field1.field2
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN unknown_identifier..10
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN unknown_identifier.field1..10
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier.field1
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN unknown_identifier.field1.field2..10
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR 42000: Undeclared variable: field1.field2
+CREATE PROCEDURE p1() AS
+a INT DEFAULT unknown_identifier;
+BEGIN
+SELECT a;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE PROCEDURE p1() AS
+a INT DEFAULT unknown_identifier.a;
+BEGIN
+SELECT a;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE PROCEDURE p1() AS
+a INT DEFAULT unknown_identifier.a.b;
+BEGIN
+SELECT a;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier; END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier.a; END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier.a.b; END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier.a.b.c; END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+CREATE PROCEDURE p1() AS
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(unknown_identifier);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'ORDER clause'
+CREATE PROCEDURE p1() AS
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(unknown_identifier.a);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'ORDER clause'
+CREATE PROCEDURE p1() AS
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(unknown_identifier.a.b);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'ORDER clause'
+CREATE PROCEDURE p1() AS
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(unknown_identifier.a.b.c);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'ORDER clause'
+DROP TABLE t1;
+#
+# MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+#
+# (testing aggregate functions)
+CREATE PROCEDURE p1() AS
+BEGIN
+CASE SUM(1) WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1() AS
+BEGIN
+IF SUM(1) THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1() AS
+BEGIN
+WHILE SUM(1) LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1() AS
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL SUM(1);
+END REPEAT;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN 0..SUM(1)
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN SUM(1)..10
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1() AS
+a INT DEFAULT SUM(1);
+BEGIN
+SELECT a;
+END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN SUM(1); END;
+$$
+ERROR HY000: Invalid use of group function
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+CREATE PROCEDURE p1() AS
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(SUM(1));
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR HY000: Invalid use of group function
+DROP TABLE t1;
+#
+# MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+#
+# (testing window functions)
+CREATE PROCEDURE p1() AS
+BEGIN
+CASE ROW_NUMBER() OVER() WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+BEGIN
+IF ROW_NUMBER() OVER() THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+BEGIN
+WHILE ROW_NUMBER() OVER() LOOP
+SELECT 1;
+END LOOP;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+BEGIN
+REPEAT
+SELECT 1;
+UNTIL ROW_NUMBER() OVER();
+END REPEAT;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN 0..ROW_NUMBER() OVER()
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+BEGIN
+FOR i IN ROW_NUMBER() OVER()..10
+LOOP
+SELECT i;
+END LOOP;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+a INT DEFAULT ROW_NUMBER() OVER();
+BEGIN
+SELECT a;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN ROW_NUMBER() OVER(); END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+CREATE PROCEDURE p1() AS
+va INT;
+CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+OPEN cur(ROW_NUMBER() OVER());
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+DROP TABLE t1;
diff --git a/mysql-test/suite/compat/oracle/r/sp.result b/mysql-test/suite/compat/oracle/r/sp.result
index 7f04282..2049f23 100644
--- a/mysql-test/suite/compat/oracle/r/sp.result
+++ b/mysql-test/suite/compat/oracle/r/sp.result
@@ -1019,9 +1019,7 @@ LOOP
 EXIT WHEN unknown_ident IS NULL;
 END LOOP;
 END$$
-CALL p1;
 ERROR 42S22: Unknown column 'unknown_ident' in 'field list'
-DROP PROCEDURE p1;
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1030,9 +1028,7 @@ LOOP
 EXIT label WHEN unknown_ident IS NULL;
 END LOOP;
 END$$
-CALL p1;
 ERROR 42S22: Unknown column 'unknown_ident' in 'field list'
-DROP PROCEDURE p1;
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1040,9 +1036,7 @@ LOOP
 CONTINUE WHEN unknown_ident IS NULL;
 END LOOP;
 END$$
-CALL p1;
 ERROR 42S22: Unknown column 'unknown_ident' in 'field list'
-DROP PROCEDURE p1;
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1051,9 +1045,7 @@ LOOP
 CONTINUE label WHEN unknown_ident IS NULL;
 END LOOP;
 END$$
-CALL p1;
 ERROR 42S22: Unknown column 'unknown_ident' in 'field list'
-DROP PROCEDURE p1;
 #
 # MDEV-10583 sql_mode=ORACLE: SQL%ROWCOUNT
 #
diff --git a/mysql-test/suite/compat/oracle/r/statement-expr.result b/mysql-test/suite/compat/oracle/r/statement-expr.result
new file mode 100644
index 0000000..3f37a22
--- /dev/null
+++ b/mysql-test/suite/compat/oracle/r/statement-expr.result
@@ -0,0 +1,222 @@
+SET sql_mode=ORACLE;
+CREATE TABLE t1 (id INT, id1 INT);
+INSERT INTO t1 VALUES (1,7);
+INSERT INTO t1 VALUES (1,8);
+SELECT ROW(1,7) IN (SELECT id, id1 FROM t1 WHERE id1= 8);
+ROW(1,7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)
+0
+EXECUTE IMMEDIATE 'SELECT ROW(1, 7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)';
+ROW(1, 7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)
+0
+DROP TABLE t1;
+EXECUTE IMMEDIATE 'SELECT ?' USING (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+EXECUTE IMMEDIATE 'SELECT ?' USING (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1)' at line 1
+CREATE TABLE t1 (id INT);
+INSERT INTO t1 VALUES (10);
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+CALL p1((1) IN (SELECT * FROM t1));
+CALL p1(EXISTS (SELECT * FROM t1));
+DROP PROCEDURE p1;
+DROP TABLE t1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(1 IN (SELECT * FROM t1))' at line 1
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'EXISTS (SELECT * FROM t1)' at line 1
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(1 IN (SELECT * FROM t1));
+SIGNAL SQLSTATE '01000';
+END' at line 3
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'EXISTS (SELECT * FROM t1);
+SIGNAL SQLSTATE '01000';
+END' at line 3
+PREPARE stmt FROM (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+PREPARE stmt FROM EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(SELECT * FROM t1)' at line 1
+EXECUTE IMMEDIATE (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+EXECUTE IMMEDIATE EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(SELECT * FROM t1)' at line 1
+GET DIAGNOSTICS CONDITION (1 IN (SELECT * FROM t1)) @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(1 IN (SELECT * FROM t1)) @errno=MYSQL_ERRNO' at line 1
+GET DIAGNOSTICS CONDITION EXISTS (SELECT * FROM t1) @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'EXISTS (SELECT * FROM t1) @errno=MYSQL_ERRNO' at line 1
+PURGE BINARY LOGS BEFORE (1 IN (SELECT * FROM t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SELECT * FROM t1))' at line 1
+PURGE BINARY LOGS BEFORE EXISTS (SELECT * FROM t1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near '(SELECT * FROM t1)' at line 1
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DO 1 IN (SELECT * FROM t1);
+DO EXISTS (SELECT * FROM t1);
+DROP TABLE t1;
+#
+# MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+#
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+CALL p1(unknown_identifier);
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CALL p1(unknown_identifier.a);
+ERROR 42S22: Unknown column 'a' in 'field list'
+CALL p1(unknown_identifier.a.b);
+ERROR 42S22: Unknown column 'b' in 'field list'
+CALL p1(unknown_identifier.a.b.c);
+ERROR 42S22: Unknown column 'b' in 'field list'
+DROP PROCEDURE p1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+PREPARE stmt FROM unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+PREPARE stmt FROM unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+PREPARE stmt FROM unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+PREPARE stmt FROM unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+EXECUTE IMMEDIATE unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier.a @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'a' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'b' in 'field list'
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b.c @errno=MYSQL_ERRNO;
+ERROR 42S22: Unknown column 'b' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+#
+# MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+#
+# (aggreate functions)
+EXECUTE IMMEDIATE 'SELECT ?' USING SUM(1);
+ERROR HY000: Invalid use of group function
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+CALL p1(SUM(1));
+ERROR HY000: Invalid use of group function
+DROP PROCEDURE p1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=SUM(1);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SUM(1)' at line 1
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=SUM(1);
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SUM(1);
+SIGNAL SQLSTATE '01000';
+END' at line 3
+PREPARE stmt FROM SUM(1);
+ERROR HY000: Invalid use of group function
+EXECUTE IMMEDIATE SUM(1);
+ERROR HY000: Invalid use of group function
+GET DIAGNOSTICS CONDITION SUM(1) @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'SUM(1) @errno=MYSQL_ERRNO' at line 1
+PURGE BINARY LOGS BEFORE SUM(1);
+ERROR HY000: Invalid use of group function
+#
+# MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+#
+# (window functions)
+EXECUTE IMMEDIATE 'SELECT ?' USING ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+CALL p1(ROW_NUMBER() OVER ());
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+DROP PROCEDURE p1;
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'ROW_NUMBER() OVER ()' at line 1
+BEGIN NOT ATOMIC
+DECLARE CONTINUE HANDLER FOR SQLWARNING
+RESIGNAL SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+SIGNAL SQLSTATE '01000';
+END;
+$$
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'ROW_NUMBER() OVER ();
+SIGNAL SQLSTATE '01000';
+END' at line 3
+PREPARE stmt FROM ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+EXECUTE IMMEDIATE ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+GET DIAGNOSTICS CONDITION ROW_NUMBER() OVER () @errno=MYSQL_ERRNO;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'ROW_NUMBER() OVER () @errno=MYSQL_ERRNO' at line 1
+PURGE BINARY LOGS BEFORE ROW_NUMBER() OVER ();
+ERROR HY000: Window function is allowed only in SELECT list and ORDER BY clause
+CREATE PROCEDURE p1() AS
+BEGIN
+DO unknown_identifier;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
